﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, October 17, 2008 5:25:12 PM
// Code is generated using templates: SD.TemplateBindings.Linq
// Templates vendor: Solutions Design.
//////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using SD.LLBLGen.Pro.LinqSupportClasses;
using SD.LLBLGen.Pro.ORMSupportClasses;

using NorthwindAdapter;
using NorthwindAdapter.EntityClasses;
using NorthwindAdapter.FactoryClasses;
using NorthwindAdapter.HelperClasses;
using NorthwindAdapter.RelationClasses;

namespace NorthwindAdapter.Linq
{
	/// <summary>Meta-data class for the construction of Linq queries which are to be executed using LLBLGen Pro code.</summary>
	public class LinqMetaData: ILinqMetaData
	{
		#region Class Member Declarations
		private IDataAccessAdapter _adapterToUse;
		private FunctionMappingStore _customFunctionMappings;
		private Context _contextToUse;
		#endregion
		
		/// <summary>CTor. Using this ctor will leave the IDataAccessAdapter object to use empty. To be able to execute the query, an IDataAccessAdapter instance
		/// is required, and has to be set on the LLBLGenProProvider2 object in the query to execute. </summary>
		public LinqMetaData() : this(null, null)
		{
		}
		
		/// <summary>CTor which accepts an IDataAccessAdapter implementing object, which will be used to execute queries created with this metadata class.</summary>
		/// <param name="adapterToUse">the IDataAccessAdapter to use in queries created with this meta data</param>
		/// <remarks> Be aware that the IDataAccessAdapter object set via this property is kept alive by the LLBLGenProQuery objects created with this meta data
		/// till they go out of scope.</remarks>
		public LinqMetaData(IDataAccessAdapter adapterToUse) : this (adapterToUse, null)
		{
		}

		/// <summary>CTor which accepts an IDataAccessAdapter implementing object, which will be used to execute queries created with this metadata class.</summary>
		/// <param name="adapterToUse">the IDataAccessAdapter to use in queries created with this meta data</param>
		/// <param name="customFunctionMappings">The custom function mappings to use. These take higher precedence than the ones in the DQE to use.</param>
		/// <remarks> Be aware that the IDataAccessAdapter object set via this property is kept alive by the LLBLGenProQuery objects created with this meta data
		/// till they go out of scope.</remarks>
		public LinqMetaData(IDataAccessAdapter adapterToUse, FunctionMappingStore customFunctionMappings)
		{
			_adapterToUse = adapterToUse;
			_customFunctionMappings = customFunctionMappings;
		}
	
		/// <summary>returns the datasource to use in a Linq query for the entity type specified</summary>
		/// <param name="typeOfEntity">the type of the entity to get the datasource for</param>
		/// <returns>the requested datasource</returns>
		public IDataSource GetQueryableForEntity(int typeOfEntity)
		{
			IDataSource toReturn = null;
			switch((NorthwindAdapter.EntityType)typeOfEntity)
			{
				case NorthwindAdapter.EntityType.AlphabeticalListOfProductsEntity:
					toReturn = this.AlphabeticalListOfProducts;
					break;
				case NorthwindAdapter.EntityType.CategoriesEntity:
					toReturn = this.Categories;
					break;
				case NorthwindAdapter.EntityType.CategorySalesFor1997Entity:
					toReturn = this.CategorySalesFor1997;
					break;
				case NorthwindAdapter.EntityType.CurrentProductListEntity:
					toReturn = this.CurrentProductList;
					break;
				case NorthwindAdapter.EntityType.CustomerAndSuppliersByCityEntity:
					toReturn = this.CustomerAndSuppliersByCity;
					break;
				case NorthwindAdapter.EntityType.CustomerCustomerDemoEntity:
					toReturn = this.CustomerCustomerDemo;
					break;
				case NorthwindAdapter.EntityType.CustomerDemographicsEntity:
					toReturn = this.CustomerDemographics;
					break;
				case NorthwindAdapter.EntityType.CustomersEntity:
					toReturn = this.Customers;
					break;
				case NorthwindAdapter.EntityType.EmployeesEntity:
					toReturn = this.Employees;
					break;
				case NorthwindAdapter.EntityType.EmployeeTerritoriesEntity:
					toReturn = this.EmployeeTerritories;
					break;
				case NorthwindAdapter.EntityType.InvoicesEntity:
					toReturn = this.Invoices;
					break;
				case NorthwindAdapter.EntityType.OrderDetailsEntity:
					toReturn = this.OrderDetails;
					break;
				case NorthwindAdapter.EntityType.OrderDetailsExtendedEntity:
					toReturn = this.OrderDetailsExtended;
					break;
				case NorthwindAdapter.EntityType.OrdersEntity:
					toReturn = this.Orders;
					break;
				case NorthwindAdapter.EntityType.OrdersQryEntity:
					toReturn = this.OrdersQry;
					break;
				case NorthwindAdapter.EntityType.OrderSubtotalsEntity:
					toReturn = this.OrderSubtotals;
					break;
				case NorthwindAdapter.EntityType.ProductsEntity:
					toReturn = this.Products;
					break;
				case NorthwindAdapter.EntityType.ProductsAboveAveragePriceEntity:
					toReturn = this.ProductsAboveAveragePrice;
					break;
				case NorthwindAdapter.EntityType.ProductSalesFor1997Entity:
					toReturn = this.ProductSalesFor1997;
					break;
				case NorthwindAdapter.EntityType.ProductsByCategoryEntity:
					toReturn = this.ProductsByCategory;
					break;
				case NorthwindAdapter.EntityType.QuarterlyOrdersEntity:
					toReturn = this.QuarterlyOrders;
					break;
				case NorthwindAdapter.EntityType.RegionEntity:
					toReturn = this.Region;
					break;
				case NorthwindAdapter.EntityType.SalesByCategoryEntity:
					toReturn = this.SalesByCategory;
					break;
				case NorthwindAdapter.EntityType.SalesTotalsByAmountEntity:
					toReturn = this.SalesTotalsByAmount;
					break;
				case NorthwindAdapter.EntityType.ShippersEntity:
					toReturn = this.Shippers;
					break;
				case NorthwindAdapter.EntityType.SummaryOfSalesByQuarterEntity:
					toReturn = this.SummaryOfSalesByQuarter;
					break;
				case NorthwindAdapter.EntityType.SummaryOfSalesByYearEntity:
					toReturn = this.SummaryOfSalesByYear;
					break;
				case NorthwindAdapter.EntityType.SuppliersEntity:
					toReturn = this.Suppliers;
					break;
				case NorthwindAdapter.EntityType.TerritoriesEntity:
					toReturn = this.Territories;
					break;
				default:
					toReturn = null;
					break;
			}
			return toReturn;
		}

		/// <summary>returns the datasource to use in a Linq query when targeting AlphabeticalListOfProductsEntity instances in the database.</summary>
		public DataSource2<AlphabeticalListOfProductsEntity> AlphabeticalListOfProducts
		{
			get { return new DataSource2<AlphabeticalListOfProductsEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CategoriesEntity instances in the database.</summary>
		public DataSource2<CategoriesEntity> Categories
		{
			get { return new DataSource2<CategoriesEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CategorySalesFor1997Entity instances in the database.</summary>
		public DataSource2<CategorySalesFor1997Entity> CategorySalesFor1997
		{
			get { return new DataSource2<CategorySalesFor1997Entity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CurrentProductListEntity instances in the database.</summary>
		public DataSource2<CurrentProductListEntity> CurrentProductList
		{
			get { return new DataSource2<CurrentProductListEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CustomerAndSuppliersByCityEntity instances in the database.</summary>
		public DataSource2<CustomerAndSuppliersByCityEntity> CustomerAndSuppliersByCity
		{
			get { return new DataSource2<CustomerAndSuppliersByCityEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CustomerCustomerDemoEntity instances in the database.</summary>
		public DataSource2<CustomerCustomerDemoEntity> CustomerCustomerDemo
		{
			get { return new DataSource2<CustomerCustomerDemoEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CustomerDemographicsEntity instances in the database.</summary>
		public DataSource2<CustomerDemographicsEntity> CustomerDemographics
		{
			get { return new DataSource2<CustomerDemographicsEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting CustomersEntity instances in the database.</summary>
		public DataSource2<CustomersEntity> Customers
		{
			get { return new DataSource2<CustomersEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting EmployeesEntity instances in the database.</summary>
		public DataSource2<EmployeesEntity> Employees
		{
			get { return new DataSource2<EmployeesEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting EmployeeTerritoriesEntity instances in the database.</summary>
		public DataSource2<EmployeeTerritoriesEntity> EmployeeTerritories
		{
			get { return new DataSource2<EmployeeTerritoriesEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting InvoicesEntity instances in the database.</summary>
		public DataSource2<InvoicesEntity> Invoices
		{
			get { return new DataSource2<InvoicesEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting OrderDetailsEntity instances in the database.</summary>
		public DataSource2<OrderDetailsEntity> OrderDetails
		{
			get { return new DataSource2<OrderDetailsEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting OrderDetailsExtendedEntity instances in the database.</summary>
		public DataSource2<OrderDetailsExtendedEntity> OrderDetailsExtended
		{
			get { return new DataSource2<OrderDetailsExtendedEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting OrdersEntity instances in the database.</summary>
		public DataSource2<OrdersEntity> Orders
		{
			get { return new DataSource2<OrdersEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting OrdersQryEntity instances in the database.</summary>
		public DataSource2<OrdersQryEntity> OrdersQry
		{
			get { return new DataSource2<OrdersQryEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting OrderSubtotalsEntity instances in the database.</summary>
		public DataSource2<OrderSubtotalsEntity> OrderSubtotals
		{
			get { return new DataSource2<OrderSubtotalsEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting ProductsEntity instances in the database.</summary>
		public DataSource2<ProductsEntity> Products
		{
			get { return new DataSource2<ProductsEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting ProductsAboveAveragePriceEntity instances in the database.</summary>
		public DataSource2<ProductsAboveAveragePriceEntity> ProductsAboveAveragePrice
		{
			get { return new DataSource2<ProductsAboveAveragePriceEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting ProductSalesFor1997Entity instances in the database.</summary>
		public DataSource2<ProductSalesFor1997Entity> ProductSalesFor1997
		{
			get { return new DataSource2<ProductSalesFor1997Entity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting ProductsByCategoryEntity instances in the database.</summary>
		public DataSource2<ProductsByCategoryEntity> ProductsByCategory
		{
			get { return new DataSource2<ProductsByCategoryEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting QuarterlyOrdersEntity instances in the database.</summary>
		public DataSource2<QuarterlyOrdersEntity> QuarterlyOrders
		{
			get { return new DataSource2<QuarterlyOrdersEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting RegionEntity instances in the database.</summary>
		public DataSource2<RegionEntity> Region
		{
			get { return new DataSource2<RegionEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting SalesByCategoryEntity instances in the database.</summary>
		public DataSource2<SalesByCategoryEntity> SalesByCategory
		{
			get { return new DataSource2<SalesByCategoryEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting SalesTotalsByAmountEntity instances in the database.</summary>
		public DataSource2<SalesTotalsByAmountEntity> SalesTotalsByAmount
		{
			get { return new DataSource2<SalesTotalsByAmountEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting ShippersEntity instances in the database.</summary>
		public DataSource2<ShippersEntity> Shippers
		{
			get { return new DataSource2<ShippersEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting SummaryOfSalesByQuarterEntity instances in the database.</summary>
		public DataSource2<SummaryOfSalesByQuarterEntity> SummaryOfSalesByQuarter
		{
			get { return new DataSource2<SummaryOfSalesByQuarterEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting SummaryOfSalesByYearEntity instances in the database.</summary>
		public DataSource2<SummaryOfSalesByYearEntity> SummaryOfSalesByYear
		{
			get { return new DataSource2<SummaryOfSalesByYearEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting SuppliersEntity instances in the database.</summary>
		public DataSource2<SuppliersEntity> Suppliers
		{
			get { return new DataSource2<SuppliersEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		/// <summary>returns the datasource to use in a Linq query when targeting TerritoriesEntity instances in the database.</summary>
		public DataSource2<TerritoriesEntity> Territories
		{
			get { return new DataSource2<TerritoriesEntity>(_adapterToUse, new ElementCreator(), _customFunctionMappings, _contextToUse); }
		}
		
		
		#region Class Property Declarations
		/// <summary> Gets / sets the IDataAccessAdapter to use for the queries created with this meta data object.</summary>
		/// <remarks> Be aware that the IDataAccessAdapter object set via this property is kept alive by the LLBLGenProQuery objects created with this meta data
		/// till they go out of scope.</remarks>
		public IDataAccessAdapter AdapterToUse
		{
			get { return _adapterToUse;}
			set { _adapterToUse = value;}
		}

		/// <summary>Gets or sets the custom function mappings to use. These take higher precedence than the ones in the DQE to use</summary>
		public FunctionMappingStore CustomFunctionMappings
		{
			get { return _customFunctionMappings; }
			set { _customFunctionMappings = value; }
		}
		
		/// <summary>Gets or sets the Context instance to use for entity fetches.</summary>
		public Context ContextToUse
		{
			get { return _contextToUse;}
			set { _contextToUse = value;}
		}
		#endregion
	}
}